class ConformerEncoder(Module):
  __parameters__ = []
  __buffers__ = []
  embed : __torch__.cosyvoice.transformer.subsampling.___torch_mangle_6.LinearNoSubsampling
  def forward(self: __torch__.cosyvoice.transformer.encoder.___torch_mangle_5.ConformerEncoder,
    xs: Tensor,
    xs_lens: Tensor,
    decoding_chunk_size: int=0,
    num_decoding_left_chunks: int=-1) -> Tuple[Tensor, Tensor]:
    T = torch.size(xs, 1)
    batch_size = torch.size(xs_lens, 0)
    if torch.gt(T, 0):
      max_len = T
    else:
      max_len = torch.item(torch.max(xs_lens))
    seq_range = torch.arange(0, max_len, dtype=4, layout=None, device=ops.prim.device(xs_lens))
    seq_range_expand = torch.expand(torch.unsqueeze(seq_range, 0), [batch_size, int(max_len)])
    seq_length_expand = torch.unsqueeze(xs_lens, -1)
    mask = torch.ge(seq_range_expand, seq_length_expand)
    masks = torch.bitwise_not(torch.unsqueeze(mask, 1))
    embed = self.embed
    _0 = torch.add(torch.matmul(xs, CONSTANTS.c0), CONSTANTS.c1)
    input = torch.layer_norm(_0, [1024], CONSTANTS.c2, CONSTANTS.c3)
    pos_enc = embed.pos_enc
    pe = pos_enc.pe
    _1 = torch.size(pe, 1)
    _2 = torch.size(input, 1)
    _3 = torch.ge(_1, torch.sub(torch.mul(_2, 2), 1))
    if _3:
      pe0 = pos_enc.pe
      _4 = ops.prim.dtype(pe0)
      _5 = ops.prim.dtype(input)
      if torch.ne(_4, _5):
        _6 = True
      else:
        pe1 = pos_enc.pe
        _7 = torch.ne(ops.prim.device(pe1), ops.prim.device(input))
        _6 = _7
      if _6:
        pe2 = pos_enc.pe
        _8 = torch.to(pe2, ops.prim.device(input), _5)
        pos_enc.pe = _8
      else:
        pass
    else:
      _9 = [_2, 1024]
      pe_positive = torch.zeros(_9)
      pe_negative = torch.zeros(_9)
      position = torch.unsqueeze(torch.arange(0, _2, dtype=6), 1)
      _10 = torch.mul(position, CONSTANTS.c4)
      _11 = torch.sin(_10)
      _12 = torch.slice(torch.slice(pe_positive), 1, 0, None, 2)
      _13 = torch.copy_(_12, _11)
      _14 = torch.cos(_10)
      _15 = torch.slice(torch.slice(pe_positive), 1, 1, None, 2)
      _16 = torch.copy_(_15, _14)
      _17 = torch.mul(torch.mul(position, -1), CONSTANTS.c4)
      _18 = torch.sin(_17)
      _19 = torch.slice(torch.slice(pe_negative), 1, 0, None, 2)
      _20 = torch.copy_(_19, _18)
      _21 = torch.cos(_17)
      _22 = torch.slice(torch.slice(pe_negative), 1, 1, None, 2)
      _23 = torch.copy_(_22, _21)
      pe_positive0 = torch.unsqueeze(torch.flip(pe_positive, [0]), 0)
      pe_negative0 = torch.unsqueeze(torch.slice(pe_negative, 0, 1), 0)
      pe3 = torch.cat([pe_positive0, pe_negative0], 1)
      _24 = torch.to(pe3, ops.prim.device(input), ops.prim.dtype(input))
      pos_enc.pe = _24
    x = torch.mul(input, 32.)
    _25 = torch.size(x, 1)
    pe4 = pos_enc.pe
    _26 = torch.slice(pe4)
    pe5 = pos_enc.pe
    _27 = torch.floordiv(torch.size(pe5, 1), 2)
    _28 = torch.add(torch.sub(_27, _25), 1)
    pe6 = pos_enc.pe
    _29 = torch.floordiv(torch.size(pe6, 1), 2)
    pos_emb = torch.slice(_26, 1, _28, torch.add(_29, _25))
    _30 = torch.size(x, 1)
    _31 = ops.prim.device(x)
    chunk_masks = torch.zeros([_30, _30], dtype=11, layout=None, device=_31)
    for i in range(_30):
      _32 = torch.lt(num_decoding_left_chunks, 0)
      if _32:
        start = 0
      else:
        _33 = torch.sub(i, num_decoding_left_chunks)
        start = ops.prim.max(_33, 0)
      ending = ops.prim.min(torch.add(i, 1), _30)
      _34 = torch.slice(torch.select(chunk_masks, 0, i), 0, start, ending)
      _35 = torch.tensor(True, dtype=ops.prim.dtype(_34), device=ops.prim.device(_34))
      _36 = torch.copy_(_34, _35)
    chunk_masks0 = torch.unsqueeze(chunk_masks, 0)
    chunk_masks1 = torch.__and__(masks, chunk_masks0)
    x0 = torch.layer_norm(x, [1024], CONSTANTS.c5, CONSTANTS.c6)
    n_batch = torch.size(x0, 0)
    _37 = torch.add(torch.matmul(x0, CONSTANTS.c7), CONSTANTS.c8)
    _38 = torch.slice(_37, -1, 2048, 3072)
    _39 = torch.slice(_37, -1, 1024, 2048)
    _40 = torch.slice(_37, -1, 0, 1024)
    _41 = [n_batch, -1, 16, 64]
    q = torch.view(_40, _41)
    k = torch.view(_39, _41)
    v = torch.view(_38, _41)
    q0 = torch.transpose(q, 1, 2)
    k0 = torch.transpose(k, 1, 2)
    v0 = torch.transpose(v, 1, 2)
    q1 = torch.transpose(q0, 1, 2)
    n_batch_pos = torch.size(pos_emb, 0)
    _42 = torch.matmul(pos_emb, CONSTANTS.c9)
    _43 = [n_batch_pos, -1, 16, 64]
    p = torch.view(_42, _43)
    p0 = torch.transpose(p, 1, 2)
    q_with_bias_u = torch.transpose(torch.add(q1, CONSTANTS.c10), 1, 2)
    q_with_bias_v = torch.transpose(torch.add(q1, CONSTANTS.c11), 1, 2)
    matrix_ac = torch.matmul(q_with_bias_u, torch.transpose(k0, -2, -1))
    matrix_bd = torch.matmul(q_with_bias_v, torch.transpose(p0, -2, -1))
    _44 = torch.size(matrix_ac)
    _45 = torch.size(matrix_bd)
    if torch.ne(_44, _45):
      _46 = _45[0]
      _47 = _45[1]
      _48 = _45[2]
      _49 = ops.prim.device(matrix_bd)
      _50 = ops.prim.dtype(matrix_bd)
      zero_pad = torch.zeros([_46, _47, _48, 1], dtype=_50, layout=None, device=_49)
      x_padded = torch.cat([zero_pad, matrix_bd], -1)
      _51 = torch.add(torch.size(matrix_bd, 3), 1)
      _52 = [_46, _47, _51, torch.size(matrix_bd, 2)]
      x_padded0 = torch.view(x_padded, _52)
      _53 = torch.slice(torch.slice(x_padded0), 1)
      _54 = torch.view_as(torch.slice(_53, 2, 1), matrix_bd)
      _55 = torch.slice(torch.slice(torch.slice(_54), 1), 2)
      _56 = torch.floordiv(torch.size(matrix_bd, -1), 2)
      matrix_bd1 = torch.slice(_55, 3, None, torch.add(_56, 1))
      matrix_bd0 = matrix_bd1
    else:
      matrix_bd0 = matrix_bd
    scores = torch.div(torch.add(matrix_ac, matrix_bd0), 8.)
    n_batch0 = torch.size(v0, 0)
    _57 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _57:
      mask0 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _58 = torch.slice(torch.slice(mask0), 1)
      mask1 = torch.slice(torch.slice(_58, 2), 3, None, torch.size(scores, -1))
      scores0 = torch.masked_fill(scores, mask1, -inf)
      attn0 = torch.masked_fill(torch.softmax(scores0, -1), mask1, 0.)
      attn = attn0
    else:
      attn = torch.softmax(scores, -1)
    x1 = torch.matmul(attn, v0)
    _59 = torch.contiguous(torch.transpose(x1, 1, 2))
    x2 = torch.view(_59, [n_batch0, -1, 1024])
    _60 = torch.add(torch.matmul(x2, CONSTANTS.c12), CONSTANTS.c13)
    x3 = torch.add(x, _60)
    x4 = torch.layer_norm(x3, [1024], CONSTANTS.c14, CONSTANTS.c15)
    _61 = torch.add(torch.matmul(x4, CONSTANTS.c16), CONSTANTS.c17)
    _62 = torch.matmul(torch.silu(_61), CONSTANTS.c18)
    _63 = torch.mul(torch.add(_62, CONSTANTS.c19), 1.)
    x5 = torch.add(x3, _63)
    x6 = torch.layer_norm(x5, [1024], CONSTANTS.c20, CONSTANTS.c21)
    n_batch1 = torch.size(x6, 0)
    _64 = torch.add(torch.matmul(x6, CONSTANTS.c22), CONSTANTS.c23)
    _65 = torch.slice(_64, -1, 2048, 3072)
    _66 = torch.slice(_64, -1, 1024, 2048)
    _67 = torch.slice(_64, -1, 0, 1024)
    _68 = [n_batch1, -1, 16, 64]
    q2 = torch.view(_67, _68)
    k1 = torch.view(_66, _68)
    v1 = torch.view(_65, _68)
    q3 = torch.transpose(q2, 1, 2)
    k2 = torch.transpose(k1, 1, 2)
    v2 = torch.transpose(v1, 1, 2)
    q4 = torch.transpose(q3, 1, 2)
    _69 = torch.matmul(pos_emb, CONSTANTS.c24)
    p1 = torch.view(_69, _43)
    p2 = torch.transpose(p1, 1, 2)
    q_with_bias_u0 = torch.transpose(torch.add(q4, CONSTANTS.c25), 1, 2)
    q_with_bias_v0 = torch.transpose(torch.add(q4, CONSTANTS.c26), 1, 2)
    matrix_ac0 = torch.matmul(q_with_bias_u0, torch.transpose(k2, -2, -1))
    matrix_bd2 = torch.matmul(q_with_bias_v0, torch.transpose(p2, -2, -1))
    _70 = torch.size(matrix_ac0)
    _71 = torch.size(matrix_bd2)
    if torch.ne(_70, _71):
      _72 = _71[0]
      _73 = _71[1]
      _74 = _71[2]
      _75 = ops.prim.device(matrix_bd2)
      _76 = ops.prim.dtype(matrix_bd2)
      zero_pad0 = torch.zeros([_72, _73, _74, 1], dtype=_76, layout=None, device=_75)
      x_padded1 = torch.cat([zero_pad0, matrix_bd2], -1)
      _77 = torch.add(torch.size(matrix_bd2, 3), 1)
      _78 = [_72, _73, _77, torch.size(matrix_bd2, 2)]
      x_padded2 = torch.view(x_padded1, _78)
      _79 = torch.slice(torch.slice(x_padded2), 1)
      _80 = torch.view_as(torch.slice(_79, 2, 1), matrix_bd2)
      _81 = torch.slice(torch.slice(torch.slice(_80), 1), 2)
      _82 = torch.floordiv(torch.size(matrix_bd2, -1), 2)
      matrix_bd4 = torch.slice(_81, 3, None, torch.add(_82, 1))
      matrix_bd3 = matrix_bd4
    else:
      matrix_bd3 = matrix_bd2
    scores1 = torch.div(torch.add(matrix_ac0, matrix_bd3), 8.)
    n_batch2 = torch.size(v2, 0)
    _83 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _83:
      mask2 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _84 = torch.slice(torch.slice(mask2), 1)
      mask3 = torch.slice(torch.slice(_84, 2), 3, None, torch.size(scores1, -1))
      scores2 = torch.masked_fill(scores1, mask3, -inf)
      attn2 = torch.masked_fill(torch.softmax(scores2, -1), mask3, 0.)
      attn1 = attn2
    else:
      attn1 = torch.softmax(scores1, -1)
    x7 = torch.matmul(attn1, v2)
    _85 = torch.contiguous(torch.transpose(x7, 1, 2))
    x8 = torch.view(_85, [n_batch2, -1, 1024])
    _86 = torch.add(torch.matmul(x8, CONSTANTS.c27), CONSTANTS.c28)
    x9 = torch.add(x5, _86)
    x10 = torch.layer_norm(x9, [1024], CONSTANTS.c29, CONSTANTS.c30)
    _87 = torch.add(torch.matmul(x10, CONSTANTS.c31), CONSTANTS.c32)
    _88 = torch.matmul(torch.silu(_87), CONSTANTS.c33)
    _89 = torch.mul(torch.add(_88, CONSTANTS.c34), 1.)
    x11 = torch.add(x9, _89)
    x12 = torch.layer_norm(x11, [1024], CONSTANTS.c35, CONSTANTS.c36)
    n_batch3 = torch.size(x12, 0)
    _90 = torch.add(torch.matmul(x12, CONSTANTS.c37), CONSTANTS.c38)
    _91 = torch.slice(_90, -1, 2048, 3072)
    _92 = torch.slice(_90, -1, 1024, 2048)
    _93 = torch.slice(_90, -1, 0, 1024)
    _94 = [n_batch3, -1, 16, 64]
    q5 = torch.view(_93, _94)
    k3 = torch.view(_92, _94)
    v3 = torch.view(_91, _94)
    q6 = torch.transpose(q5, 1, 2)
    k4 = torch.transpose(k3, 1, 2)
    v4 = torch.transpose(v3, 1, 2)
    q7 = torch.transpose(q6, 1, 2)
    _95 = torch.matmul(pos_emb, CONSTANTS.c39)
    p3 = torch.view(_95, _43)
    p4 = torch.transpose(p3, 1, 2)
    q_with_bias_u1 = torch.transpose(torch.add(q7, CONSTANTS.c40), 1, 2)
    q_with_bias_v1 = torch.transpose(torch.add(q7, CONSTANTS.c41), 1, 2)
    matrix_ac1 = torch.matmul(q_with_bias_u1, torch.transpose(k4, -2, -1))
    matrix_bd5 = torch.matmul(q_with_bias_v1, torch.transpose(p4, -2, -1))
    _96 = torch.size(matrix_ac1)
    _97 = torch.size(matrix_bd5)
    if torch.ne(_96, _97):
      _98 = _97[0]
      _99 = _97[1]
      _100 = _97[2]
      _101 = ops.prim.device(matrix_bd5)
      _102 = ops.prim.dtype(matrix_bd5)
      zero_pad1 = torch.zeros([_98, _99, _100, 1], dtype=_102, layout=None, device=_101)
      x_padded3 = torch.cat([zero_pad1, matrix_bd5], -1)
      _103 = torch.add(torch.size(matrix_bd5, 3), 1)
      _104 = [_98, _99, _103, torch.size(matrix_bd5, 2)]
      x_padded4 = torch.view(x_padded3, _104)
      _105 = torch.slice(torch.slice(x_padded4), 1)
      _106 = torch.view_as(torch.slice(_105, 2, 1), matrix_bd5)
      _107 = torch.slice(torch.slice(torch.slice(_106), 1), 2)
      _108 = torch.floordiv(torch.size(matrix_bd5, -1), 2)
      matrix_bd7 = torch.slice(_107, 3, None, torch.add(_108, 1))
      matrix_bd6 = matrix_bd7
    else:
      matrix_bd6 = matrix_bd5
    scores3 = torch.div(torch.add(matrix_ac1, matrix_bd6), 8.)
    n_batch4 = torch.size(v4, 0)
    _109 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _109:
      mask4 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _110 = torch.slice(torch.slice(mask4), 1)
      mask5 = torch.slice(torch.slice(_110, 2), 3, None, torch.size(scores3, -1))
      scores4 = torch.masked_fill(scores3, mask5, -inf)
      attn4 = torch.masked_fill(torch.softmax(scores4, -1), mask5, 0.)
      attn3 = attn4
    else:
      attn3 = torch.softmax(scores3, -1)
    x13 = torch.matmul(attn3, v4)
    _111 = torch.contiguous(torch.transpose(x13, 1, 2))
    x14 = torch.view(_111, [n_batch4, -1, 1024])
    _112 = torch.add(torch.matmul(x14, CONSTANTS.c42), CONSTANTS.c43)
    x15 = torch.add(x11, _112)
    x16 = torch.layer_norm(x15, [1024], CONSTANTS.c44, CONSTANTS.c45)
    _113 = torch.add(torch.matmul(x16, CONSTANTS.c46), CONSTANTS.c47)
    _114 = torch.matmul(torch.silu(_113), CONSTANTS.c48)
    _115 = torch.mul(torch.add(_114, CONSTANTS.c49), 1.)
    x17 = torch.add(x15, _115)
    x18 = torch.layer_norm(x17, [1024], CONSTANTS.c50, CONSTANTS.c51)
    n_batch5 = torch.size(x18, 0)
    _116 = torch.add(torch.matmul(x18, CONSTANTS.c52), CONSTANTS.c53)
    _117 = torch.slice(_116, -1, 2048, 3072)
    _118 = torch.slice(_116, -1, 1024, 2048)
    _119 = torch.slice(_116, -1, 0, 1024)
    _120 = [n_batch5, -1, 16, 64]
    q8 = torch.view(_119, _120)
    k5 = torch.view(_118, _120)
    v5 = torch.view(_117, _120)
    q9 = torch.transpose(q8, 1, 2)
    k6 = torch.transpose(k5, 1, 2)
    v6 = torch.transpose(v5, 1, 2)
    q10 = torch.transpose(q9, 1, 2)
    _121 = torch.matmul(pos_emb, CONSTANTS.c54)
    p5 = torch.view(_121, _43)
    p6 = torch.transpose(p5, 1, 2)
    q_with_bias_u2 = torch.transpose(torch.add(q10, CONSTANTS.c55), 1, 2)
    q_with_bias_v2 = torch.transpose(torch.add(q10, CONSTANTS.c56), 1, 2)
    matrix_ac2 = torch.matmul(q_with_bias_u2, torch.transpose(k6, -2, -1))
    matrix_bd8 = torch.matmul(q_with_bias_v2, torch.transpose(p6, -2, -1))
    _122 = torch.size(matrix_ac2)
    _123 = torch.size(matrix_bd8)
    if torch.ne(_122, _123):
      _124 = _123[0]
      _125 = _123[1]
      _126 = _123[2]
      _127 = ops.prim.device(matrix_bd8)
      _128 = ops.prim.dtype(matrix_bd8)
      zero_pad2 = torch.zeros([_124, _125, _126, 1], dtype=_128, layout=None, device=_127)
      x_padded5 = torch.cat([zero_pad2, matrix_bd8], -1)
      _129 = torch.add(torch.size(matrix_bd8, 3), 1)
      _130 = [_124, _125, _129, torch.size(matrix_bd8, 2)]
      x_padded6 = torch.view(x_padded5, _130)
      _131 = torch.slice(torch.slice(x_padded6), 1)
      _132 = torch.view_as(torch.slice(_131, 2, 1), matrix_bd8)
      _133 = torch.slice(torch.slice(torch.slice(_132), 1), 2)
      _134 = torch.floordiv(torch.size(matrix_bd8, -1), 2)
      matrix_bd10 = torch.slice(_133, 3, None, torch.add(_134, 1))
      matrix_bd9 = matrix_bd10
    else:
      matrix_bd9 = matrix_bd8
    scores5 = torch.div(torch.add(matrix_ac2, matrix_bd9), 8.)
    n_batch6 = torch.size(v6, 0)
    _135 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _135:
      mask6 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _136 = torch.slice(torch.slice(mask6), 1)
      mask7 = torch.slice(torch.slice(_136, 2), 3, None, torch.size(scores5, -1))
      scores6 = torch.masked_fill(scores5, mask7, -inf)
      attn6 = torch.masked_fill(torch.softmax(scores6, -1), mask7, 0.)
      attn5 = attn6
    else:
      attn5 = torch.softmax(scores5, -1)
    x19 = torch.matmul(attn5, v6)
    _137 = torch.contiguous(torch.transpose(x19, 1, 2))
    x20 = torch.view(_137, [n_batch6, -1, 1024])
    _138 = torch.add(torch.matmul(x20, CONSTANTS.c57), CONSTANTS.c58)
    x21 = torch.add(x17, _138)
    x22 = torch.layer_norm(x21, [1024], CONSTANTS.c59, CONSTANTS.c60)
    _139 = torch.add(torch.matmul(x22, CONSTANTS.c61), CONSTANTS.c62)
    _140 = torch.matmul(torch.silu(_139), CONSTANTS.c63)
    _141 = torch.mul(torch.add(_140, CONSTANTS.c64), 1.)
    x23 = torch.add(x21, _141)
    x24 = torch.layer_norm(x23, [1024], CONSTANTS.c65, CONSTANTS.c66)
    n_batch7 = torch.size(x24, 0)
    _142 = torch.add(torch.matmul(x24, CONSTANTS.c67), CONSTANTS.c68)
    _143 = torch.slice(_142, -1, 2048, 3072)
    _144 = torch.slice(_142, -1, 1024, 2048)
    _145 = torch.slice(_142, -1, 0, 1024)
    _146 = [n_batch7, -1, 16, 64]
    q11 = torch.view(_145, _146)
    k7 = torch.view(_144, _146)
    v7 = torch.view(_143, _146)
    q12 = torch.transpose(q11, 1, 2)
    k8 = torch.transpose(k7, 1, 2)
    v8 = torch.transpose(v7, 1, 2)
    q13 = torch.transpose(q12, 1, 2)
    _147 = torch.matmul(pos_emb, CONSTANTS.c69)
    p7 = torch.view(_147, _43)
    p8 = torch.transpose(p7, 1, 2)
    q_with_bias_u3 = torch.transpose(torch.add(q13, CONSTANTS.c70), 1, 2)
    q_with_bias_v3 = torch.transpose(torch.add(q13, CONSTANTS.c71), 1, 2)
    matrix_ac3 = torch.matmul(q_with_bias_u3, torch.transpose(k8, -2, -1))
    matrix_bd11 = torch.matmul(q_with_bias_v3, torch.transpose(p8, -2, -1))
    _148 = torch.size(matrix_ac3)
    _149 = torch.size(matrix_bd11)
    if torch.ne(_148, _149):
      _150 = _149[0]
      _151 = _149[1]
      _152 = _149[2]
      _153 = ops.prim.device(matrix_bd11)
      _154 = ops.prim.dtype(matrix_bd11)
      zero_pad3 = torch.zeros([_150, _151, _152, 1], dtype=_154, layout=None, device=_153)
      x_padded7 = torch.cat([zero_pad3, matrix_bd11], -1)
      _155 = torch.add(torch.size(matrix_bd11, 3), 1)
      _156 = [_150, _151, _155, torch.size(matrix_bd11, 2)]
      x_padded8 = torch.view(x_padded7, _156)
      _157 = torch.slice(torch.slice(x_padded8), 1)
      _158 = torch.view_as(torch.slice(_157, 2, 1), matrix_bd11)
      _159 = torch.slice(torch.slice(torch.slice(_158), 1), 2)
      _160 = torch.floordiv(torch.size(matrix_bd11, -1), 2)
      matrix_bd13 = torch.slice(_159, 3, None, torch.add(_160, 1))
      matrix_bd12 = matrix_bd13
    else:
      matrix_bd12 = matrix_bd11
    scores7 = torch.div(torch.add(matrix_ac3, matrix_bd12), 8.)
    n_batch8 = torch.size(v8, 0)
    _161 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _161:
      mask8 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _162 = torch.slice(torch.slice(mask8), 1)
      mask9 = torch.slice(torch.slice(_162, 2), 3, None, torch.size(scores7, -1))
      scores8 = torch.masked_fill(scores7, mask9, -inf)
      attn8 = torch.masked_fill(torch.softmax(scores8, -1), mask9, 0.)
      attn7 = attn8
    else:
      attn7 = torch.softmax(scores7, -1)
    x25 = torch.matmul(attn7, v8)
    _163 = torch.contiguous(torch.transpose(x25, 1, 2))
    x26 = torch.view(_163, [n_batch8, -1, 1024])
    _164 = torch.add(torch.matmul(x26, CONSTANTS.c72), CONSTANTS.c73)
    x27 = torch.add(x23, _164)
    x28 = torch.layer_norm(x27, [1024], CONSTANTS.c74, CONSTANTS.c75)
    _165 = torch.add(torch.matmul(x28, CONSTANTS.c76), CONSTANTS.c77)
    _166 = torch.matmul(torch.silu(_165), CONSTANTS.c78)
    _167 = torch.mul(torch.add(_166, CONSTANTS.c79), 1.)
    x29 = torch.add(x27, _167)
    x30 = torch.layer_norm(x29, [1024], CONSTANTS.c80, CONSTANTS.c81)
    n_batch9 = torch.size(x30, 0)
    _168 = torch.add(torch.matmul(x30, CONSTANTS.c82), CONSTANTS.c83)
    _169 = torch.slice(_168, -1, 2048, 3072)
    _170 = torch.slice(_168, -1, 1024, 2048)
    _171 = torch.slice(_168, -1, 0, 1024)
    _172 = [n_batch9, -1, 16, 64]
    q14 = torch.view(_171, _172)
    k9 = torch.view(_170, _172)
    v9 = torch.view(_169, _172)
    q15 = torch.transpose(q14, 1, 2)
    k10 = torch.transpose(k9, 1, 2)
    v10 = torch.transpose(v9, 1, 2)
    q16 = torch.transpose(q15, 1, 2)
    _173 = torch.matmul(pos_emb, CONSTANTS.c84)
    p9 = torch.view(_173, _43)
    p10 = torch.transpose(p9, 1, 2)
    q_with_bias_u4 = torch.transpose(torch.add(q16, CONSTANTS.c85), 1, 2)
    q_with_bias_v4 = torch.transpose(torch.add(q16, CONSTANTS.c86), 1, 2)
    matrix_ac4 = torch.matmul(q_with_bias_u4, torch.transpose(k10, -2, -1))
    matrix_bd14 = torch.matmul(q_with_bias_v4, torch.transpose(p10, -2, -1))
    _174 = torch.size(matrix_ac4)
    _175 = torch.size(matrix_bd14)
    if torch.ne(_174, _175):
      _176 = _175[0]
      _177 = _175[1]
      _178 = _175[2]
      _179 = ops.prim.device(matrix_bd14)
      _180 = ops.prim.dtype(matrix_bd14)
      zero_pad4 = torch.zeros([_176, _177, _178, 1], dtype=_180, layout=None, device=_179)
      x_padded9 = torch.cat([zero_pad4, matrix_bd14], -1)
      _181 = torch.add(torch.size(matrix_bd14, 3), 1)
      _182 = [_176, _177, _181, torch.size(matrix_bd14, 2)]
      x_padded10 = torch.view(x_padded9, _182)
      _183 = torch.slice(torch.slice(x_padded10), 1)
      _184 = torch.view_as(torch.slice(_183, 2, 1), matrix_bd14)
      _185 = torch.slice(torch.slice(torch.slice(_184), 1), 2)
      _186 = torch.floordiv(torch.size(matrix_bd14, -1), 2)
      matrix_bd16 = torch.slice(_185, 3, None, torch.add(_186, 1))
      matrix_bd15 = matrix_bd16
    else:
      matrix_bd15 = matrix_bd14
    scores9 = torch.div(torch.add(matrix_ac4, matrix_bd15), 8.)
    n_batch10 = torch.size(v10, 0)
    _187 = torch.gt(torch.size(chunk_masks1, 2), 0)
    if _187:
      mask10 = torch.eq(torch.unsqueeze(chunk_masks1, 1), 0)
      _188 = torch.slice(torch.slice(mask10), 1)
      mask11 = torch.slice(torch.slice(_188, 2), 3, None, torch.size(scores9, -1))
      scores10 = torch.masked_fill(scores9, mask11, -inf)
      attn10 = torch.masked_fill(torch.softmax(scores10, -1), mask11, 0.)
      attn9 = attn10
    else:
      attn9 = torch.softmax(scores9, -1)
    x31 = torch.matmul(attn9, v10)
    _189 = torch.contiguous(torch.transpose(x31, 1, 2))
    x32 = torch.view(_189, [n_batch10, -1, 1024])
    _190 = torch.add(torch.matmul(x32, CONSTANTS.c87), CONSTANTS.c88)
    x33 = torch.add(x29, _190)
    x34 = torch.layer_norm(x33, [1024], CONSTANTS.c89, CONSTANTS.c90)
    _191 = torch.add(torch.matmul(x34, CONSTANTS.c91), CONSTANTS.c92)
    _192 = torch.matmul(torch.silu(_191), CONSTANTS.c93)
    _193 = torch.mul(torch.add(_192, CONSTANTS.c94), 1.)
    x35 = torch.add(x33, _193)
    xs0 = torch.layer_norm(x35, [1024], CONSTANTS.c95, CONSTANTS.c96)
    return (xs0, masks)
